SaslInputStream (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.sasl.SaslInputStream,SaslInputStream class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.sasl
Class SaslInputStream

    java.lang.Object
      |
      +--java.io.InputStream
            |
            +--gnu.crypto.sasl.SaslInputStream

public class SaslInputStream
extends java.io.InputStream

An input stream that uses either a `SaslClient` or a `SaslServer` to process the data through these entities' security layer filter(s).

Constructor Summary
`SaslInputStream(SaslClient client, java.io.InputStream source)`
`SaslInputStream(SaslServer server, java.io.InputStream source)`

Method Summary
`int` | `available()`
`void` | `close()`
`int` | `read()` Reads the next byte of data from the input stream.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from the underlying source input stream into an array of bytes.

Methods inherited from class java.io.InputStream
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SaslInputStream

    public SaslInputStream(SaslClient client,
                           java.io.InputStream source)
                    throws java.io.IOException

### SaslInputStream

    public SaslInputStream(SaslServer server,
                           java.io.InputStream source)
                    throws java.io.IOException

Method Detail

### available

    public int available()
                  throws java.io.IOException

  Overrides:
    `available` in class `java.io.InputStream`
    `java.io.IOException`

### close

    public void close()
               throws java.io.IOException

  Overrides:
    `close` in class `java.io.InputStream`
    `java.io.IOException`

### read

    public int read()
             throws java.io.IOException

  Reads the next byte of data from the input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  From a SASL mechanism provider's perspective, if a security layer has been negotiated, the underlying source is expected to contain SASL buffers, as defined in RFC 2222. Four octets in network byte order in the front of each buffer identify the length of the buffer. The provider is responsible for performing any integrity checking or other processing on the buffer before returning the data as a stream of octets. For example, the protocol driver's request for a single octet from the stream might; i.e. an invocation of this method, may result in an entire SASL buffer being read and processed before that single octet can be returned.

  Specified by:
    `read` in class `java.io.InputStream`
  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException

  Reads up to `len` bytes of data from the underlying source input stream into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

  This method blocks until input data is available, end of file is detected, or an exception is thrown.

  If `b` is `null`, a `NullPointerException` is thrown.

  If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

  If `len` is zero, then no bytes are read and `0` is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value `-1` is returned; otherwise, at least one byte is read and stored into `b`.

  The first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`. Let `k` be the number of bytes actually read; these bytes will be stored in elements `b[off]` through `b[off+k-1]`, leaving elements `b[off+k]` through `b[off+len-1]` unaffected.

  In every case, elements `b[0]` through `b[off]` and elements `b[off+len]` through `b[b.length-1]` are unaffected.

  If the first byte cannot be read for any reason other than end of file, then an `IOException` is thrown. In particular, an `IOException` is thrown if the input stream has been closed.

  From the SASL mechanism provider's perspective, if a security layer has been negotiated, the underlying source is expected to contain SASL buffers, as defined in RFC 2222. Four octets in network byte order in the front of each buffer identify the length of the buffer. The provider is responsible for performing any integrity checking or other processing on the buffer before returning the data as a stream of octets. The protocol driver's request for a single octet from the stream might result in an entire SASL buffer being read and processed before that single octet can be returned.

  Overrides:
    `read` in class `java.io.InputStream`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in array `b` at which the data is wricodeen.
    `len` - the maximum number of bytes to read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.